
(function () {
    'use strict';

    var cssZubehoerClass = function (options) {
        this.init(options);
    };

    cssZubehoerClass.VERSION = '1.2.0';
    cssZubehoerClass.DEFAULTS = { 
  			showDebug : false,
  			breakpointStaffel : false,
  			staffelpreise: false,
			ioPath: '',
			maxStueckzahl:99999,
  			steuer: $("#zubehoer-bundle").data("no-tax"),
  			currency: $("#zubehoer-bundle").data("currency"),
  			itemTextCounter: $("#zubehoer-bundle").data("item-text-counter"),
  			noticeTemplate: '\
  				<div class="modal fade " id="css_zubehoer_modal" role="dialog" style="display: none;">\
			    	<div class="modal-dialog">\
			    				<div class="modal-content">\
			    			<div class="modal-header">\
			    				<h4 class="modal-title"></h4>\
			    			</div>\
    			<div class="modal-body">\
  				</div>\
			    			<!-- <form role="form" method="post" action="" >\
			    				<div class="modal-footer">\
			    					<button type="button" class="btn btn-default" data-dismiss="modal">schlie&szlig;en</button>\
			    				</div>\
			    			</form>-->\
			    		</div>\
			    	</div>\
			    </div>\
			'
    };
    cssZubehoerClass.prototype = {

        constructor: cssZubehoerClass,

        init: function (options) {
            this.options = $.extend({}, cssZubehoerClass.DEFAULTS, options);
            var that = this;
        },

        register: function(options) {
        	var that=this;
//         	this.init(options);
        	// hier kommen die initialfunktionen rein die wir aufrufen
        	var staffel = this.updateBreakPoints();
        	if(this.options.showDebug) {
        		this.debug("Array staffel:");
        		this.debug(staffel);
        		this.debug("Array breakpoints:");
        		this.debug(this.options.breakpointStaffel);
        		this.debug("Array staffelpreise:");
        		this.debug(this.options.staffelpreise);
        		this.debug("Array itemTextCounter:");
        		this.debug(this.options.itemTextCounter);
        	}	

			$("[data-toggle=\"zubehoer-tooltip\"]").on("click" , function() {
				console.log("alles klar");
// 				$(".popover").remove();
				return true;
			});
        	this.updateMaxStueckzahl();
        	this.initQuantityInput();
        	this.initCheckboxes();
        	this.initArtikelImages();
        	this.initBasketButton();
        	this.initZubehoerPopOver('bundle');
        	this.initZubehoerPopOver('zubehoer');
			this.popOverEvent();
        	$('body').on('shown.bs.modal', function () {
            that.openSlick();
        	});
      		$("body").on("click",'#css_zubehoer_modal a[aria-label="Close"]', function(e){
      			e.preventDefault();
      			$('#css_zubehoer_modal').modal("hide");			
      		});
        },
        
        debug: function(s) {
        	if(this.options.showDebug) {
        		console.log(s);
        	}
        },

        
    		openModalNotice: function (el, selector, titel,content,KeyClose) {
    			if(typeof noKeyClose === "undefined"||keyClose == true ) {
    				var keyClose = false;
    			}
    			if(keyClose === false) {
    				var backdrop = 'static';
    			} else {
    				var backdrop = true;
    			}
  				var options = {
  						show: true,
  						keyboard: keyClose,
  						backdrop: backdrop
  				}

    			$("#css_zubehoer_modal").remove();
    			$("body").append(this.options.noticeTemplate);
    			if(selector) $("#css_zubehoer_modal .modal-content").addClass(selector);
    			$("#css_zubehoer_modal .modal-title").html(titel);
    			$("#css_zubehoer_modal .modal-body").html(content);
    			$("#css_zubehoer_modal").modal(options);
    		},

		popOverEvent: function() {
			var that = this;

			$("div.zubehoer").on('show.bs.popover', function (event) {
				$(".popover").css({ marginLeft: 0 });
				$(".popover").attr("style","");
			});
			$("div.zubehoer").on('shown.bs.popover', function (event) {


setTimeout( function() {
	$(".popover.show").css({ marginLeft: 0 });

	if($(".popover.show").length == 1) {
				var el = $(".popover.show").position();
				var elWidth = 	$(".popover.show").outerWidth();
				that.debug("body-width: " + $("body").outerWidth());
				that.debug("elWidth: " + elWidth);
				that.debug("left: " + el.left);
				if(el.left < 0 ) {
					$(".popover.show").animate({ marginLeft: ((-1) * el.left) + "px" });
					that.debug("eingegriffen 2");
				} else	if(elWidth + el.left > $("body").outerWidth()) {
					$(".popover.show").animate({ marginLeft: ( (-1) * (elWidth + el.left - $("body").outerWidth())) + "px" });
					that.debug("eingegriffen 1");
				}
	}

				},800);
			});
		},

        initBasketButton:	function() {
        	var that = this;
      		$('.css-zubehoer').on('click', '[data-toggle="zubehoer-add"]', function(el) {
				that.debug("wurde geklickt");
      	    el.preventDefault();
      	    el.stopPropagation();
      	    that.putArtikelInBasket(this);
      	    return false;
      		})

        	
        	$("body").on("click","button[name='inWarenkorb']",function(e) {
        		if($(".product-offer input:invalid, .product-offer select:invalid ").length>0) {
        			return true;
        		}
        		return that.putZubehoerInBasket(e);
        	});
        	
        	$("body").on("click","#bundle-basket-button",function() {
        		that.putBundleInBasket();
        	});
        },
        
        initArtikelImages: function() {
        	$("body").on("click",".artikel-image-cell", function() {
        		var kartikeldata = $(this).data("artikel");
        		$("input#bundle-input-"+ kartikeldata).trigger("click");
        	});
        	
        },
        
        initCheckboxes: function() {
        	var that = this;
        	$("body").on("change", ".input-checkbox", function() {
        		that.updateMaxStueckzahl();
        		that.updateBreakPoints();
        		that.calcBundle();
        		$(this).blur();
        	});
        },
        
        initQuantityInput: function() {
        	var that=this;
        	$("body").on("change keyup", "#input-bundle-quantity", function() {
        		that.updateMaxStueckzahl();
        		if(that.options.maxStueckzahl < $(this).val()) {
        			$(this).val(that.options.maxStueckzahl);
        		}
        		that.calcBundle();
        	});
        },

        
        putArtikelInBasket: function(el) {
        	var that = this;
        	var and = '&';
        	$(".popover").popover('hide');
        	var rs = "io=css_zubehoer" + and + "action=putZubehoerInBasket";
        			rs = rs + and + "jtl_token=" + encodeURIComponent($("#buy_form .jtl_token").val());
           		rs = rs + and + "zubehoer["+encodeURIComponent($(el).data("artikel"))+"]" + "=" + "1";
            	this.debug(rs);
            	$("[name='inWarenkorb']").attr("disabled",true);
            	that.post_data("io.php",rs);
        },
        
        
        
        putZubehoerInBasket: function(e) {
        	var that = this;
        	var and = '&';
        	var rs = "io=css_zubehoer" + and + "action=putZubehoerInBasket";
        			rs = rs + and + "jtl_token=" + encodeURIComponent($("#buy_form .jtl_token").val());
            	var fields = '';
        			$(".zubehoer-list .zubehoer-quantity:checked").each(function() { 
        				fields = fields + and + $(this).attr("name") + "=1";
            	});
            	$(".zubehoer-list .zubehoer-quantity[type='text']").each(function() { 
            		if(Number($(this).val())>0) {
            			fields = fields + and + $(this).attr("name") + "=" + encodeURIComponent($(this).val());
            		}
            	});
            	if(fields.length<=0) {
            		that.debug("keine wk Funktion erforderlich");
            		return true;
            	}
//            	e.stopPropagation();
//            	e.preventDefault();
            	rs = rs + fields;
            	if($("input[name='VariKindArtikel']").length && $("#buy_form  [name^='eigenschaftwert']:checked, select[name^='eigenschaftwert'], input[type='text'][name^='eigenschaftwert'] ").length<=0) {
              	rs = rs + and + "zubehoer["+$("input[name='VariKindArtikel']").val()+"]" + "=" + encodeURIComponent($("#quantity").val())
            	} else {
            		rs = rs + and + "zubehoer["+$("input[name='a']").val()+"]" + "=" + encodeURIComponent($("#quantity").val())
            	}
            	if($("#buy_form  [name^='eigenschaftwert']:checked, select[name^='eigenschaftwert'], input[type='text'][name^='eigenschaftwert'] ").length) {
            		$("#buy_form   [name^='eigenschaftwert']:checked, select[name^='eigenschaftwert'], input[type='text'][name^='eigenschaftwert']").each(function() { 
              			rs = rs + and + $(this).attr("name") + "=" + encodeURIComponent($(this).val());
            		});
            	}
            	this.debug(rs);
            	$("[name='inWarenkorb']").attr("disabled",true);
            	that.post_data("io.php",rs);
            	return false;
        },
        
        putBundleInBasket: function() {
        	var that = this;
        	var and = '&';
        	var rs = "io=css_zubehoer" + and + "action=putInBasket" + and + "quantity=" + encodeURIComponent($("#input-bundle-quantity").val());
        			rs = rs + and + "jtl_token=" + encodeURIComponent($("#buy_form .jtl_token").val());
        			
        	$(".bundle-list input[type='checkbox']:checked").each(function() { 
        		rs = rs + and + encodeURIComponent($(this).attr("name")) + "=" + encodeURIComponent($(this).val());
        	});
        	this.debug(rs);
        	$("#bundle-basket-button").attr("disabled",true);
        	that.post_data("io.php",rs);
        },
        
        nextStaffel: function(quantity) {
        	for(var i=0; i< this.options.breakpointStaffel.length ; i++) {
        		if(this.options.breakpointStaffel[i] > quantity) {
        			return this.options.breakpointStaffel[i];
        		}
        	} return false;
        },
        
        updateMaxStueckzahl: function() {
        	var that = this;
        	this.options.maxStueckzahl=99999;
        	$(".bundle-list input[type='checkbox']:checked").each(function() { 
        		that.debug($(this).data('artnr') + " Lager Beachten: " + $(this).data('lagerbeachten'));
        		that.debug($(this).data('artnr') + " Ueberverkaeufe moeglich: " + $(this).data('lagerkleinernull'));
        		if($(this).data('lagerbeachten') == 'Y' && $(this).data('lagerkleinernull') == 'N'  &&  that.options.maxStueckzahl > $(this).data('lagerbestand')) {
        			that.options.maxStueckzahl = $(this).data('lagerbestand');
        		} 
        	});
        	this.debug("function: updateMaxStueckzahl = " + this.options.maxStueckzahl );
        	return this.options.maxStueckzahl;
        },
        
        updateBreakPoints: function() {
        	this.debug("function: updateBreakPoints");
        	var staffel = this.getStaffelpreise();
        	this.options.breakpointStaffel = staffel['breakpoints'];
        	this.options.staffelpreise = staffel['artikelpreise'];
        	return staffel;
        },
        
        getStaffelpreise: function () {
        	this.debug("Function: getStaffelpreise");
        	var that = this;
        	var bundleStaffel= new Array();
        	bundleStaffel['artikelpreise'] = new Array();
        	bundleStaffel['breakpoints'] = new Array();
        	$(".bundle-list input[type='checkbox']:checked").each(function() { 
        		var staffel = $(this).data('staffel');
        		if(staffel) {
        			bundleStaffel['artikelpreise'][$(this).data('artikel')] = staffel;
        			bundleStaffel['breakpoints']= jQuery.extend(bundleStaffel['breakpoints'],staffel[that.options.steuer]); 
        		} else {
        		}
        		
        	});
    			var tmp= new Array();
        	var e = 0;
        	for(var i=0; i < bundleStaffel['breakpoints'].length ; i++ ) {
        		if(typeof bundleStaffel['breakpoints'][i] !==   'undefined' &&  bundleStaffel['breakpoints'][i]>0) {
          		tmp[e++] = i;
        		}
        	}
        	bundleStaffel['breakpoints'] = tmp;
        	return bundleStaffel;
        },
        
        getBestPrice: function(el,quantity) {
        	if(typeof quantity ===  'undefined') {
        		quantity  = Number($("#input-bundle-quantity").val());
        	}
        	var price = $(el).data("preis");
        	if(typeof this.options.staffelpreise[$(el).data('artikel')] !==  'undefined') {
						for(var key in this.options.staffelpreise[$(el).data('artikel')][this.options.steuer]) {
					    if(key <= quantity) {
					    	price = this.options.staffelpreise[$(el).data('artikel')][this.options.steuer][key];
					    }
						}
					}
					return price;
        },
        
        calcBundlePrice: function(quantity) {
        	var price = 0;	
        	var that = this;
        	if(typeof quantity ===  'undefined') {
        		quantity  = Number($("#input-bundle-quantity").val());
        	}

        	$(".bundle-list input[type='checkbox']").each(function() { 
        		if($(this).prop("checked")) {
        			var bestprice = that.getBestPrice(this, quantity);
        			price += (bestprice * quantity);
        		}
        	});
					return price;
        },
        
        calcBundle: function (quantity) {
        	var that = this;
        	if(typeof quantity ===  'undefined') {
        		quantity  = Number($("#input-bundle-quantity").val());
        	}
        	var itemTextCounter = this.options.itemTextCounter;
        	
        	var price = 0;
        	var anzahl = 0;
        	$(".bundle-list input[type='checkbox']").each(function() { 
        		if($(this).prop("checked")) {
        			$(".kreuz-" + $(this).data("artikel")).not(".hidden").addClass("hidden");
        			var bestprice = that.getBestPrice(this,quantity);
        			price += bestprice * quantity;
        			anzahl += 1;
        		}else {
        			$(".kreuz-" + $(this).data("artikel")).removeClass("hidden");
        		}
        	})

        	var nextBestQuantity = this.nextStaffel(quantity);
        	if(nextBestQuantity && nextBestQuantity <= this.options.maxStueckzahl) {
        		var nextBestPrice = that.calcBundlePrice(nextBestQuantity);
        		var fixedPrice = nextBestPrice/nextBestQuantity;
      			$("#setQuantity").html(nextBestQuantity);
      			$("#nextbestPrice").show();
        		$('#bundle-next-staffel-hinweis').html("<strong>" + that.options.css_bundle_from + " " + nextBestQuantity + " " + that.options.css_bundle_per + " " + fixedPrice.toFixed(2).replace(".",",") + " "  + that.options.currency + "</strong>");
        	} else {
      			$("#nextbestPrice").hide();
        	}
        	if(anzahl <= 0) {
        		$("#bundle-basket-button").attr("disabled",true);
        	}	else {
        		$("#bundle-basket-button").attr("disabled",false);
        	}
        	if(itemTextCounter.length >= anzahl) {
        		$("#bundle-artikel-quantity").html(itemTextCounter[anzahl]);
        	} else {
        		$("#bundle-artikel-quantity").html(anzahl);
        	}
        	$("#bundle-quantity").html(quantity);
        	$("#bundle-gesamt").html(price.toFixed(2).replace(".",",") + " " +  that.options.currency);
        	
        	if(!anzahl || quantity <=0) {
        		$(".has-bundle-artikel").addClass("hidden");
        		$(".no-bundle-artikel").removeClass("hidden");
        	} else  {
        		$(".has-bundle-artikel").removeClass("hidden");
        		$(".no-bundle-artikel").addClass("hidden");
        	}
        },
        
        openSlick: function() {
        	if ($.isFunction($.fn.slick)) {
			        $('#css_zubehoer_modal .evo-slider').slick({
						    //dots: true,
						    arrows: true,
						    slidesToShow: 3,
						    responsive: [
						        {
						            breakpoint: 480, // xs
						            settings: {
						                slidesToShow: 1
						            }
						        },
						        {
						            breakpoint: 768, // sm
						            settings: {
						                slidesToShow: 2
						            }
						        },
						        {
						            breakpoint: 992, // md
						            settings: {
						                slidesToShow: 3
						            }
						        }
						    ]
						}); 
        	}   
        },

  		  initZubehoerPopOver: function(name) {
          var that = this;
  		  	that.debug("initZubehoerPopOver");
		  		$("body").on("click", ".popover .close", function(e) {
		  			that.debug("wurde geklickt");
		  			e.preventDefault();
		  			e.stopPropagation();
		  		    $(this).closest(".popover").popover('hide');
		  		});


  		  	setTimeout(function() {
  		  		$('.' + name + '-list [data-toggle="' + name + '-tooltip"]').popover({
					trigger: 'manual',
  		  			html: true, 
  						delay: {
  							show: 100,
  							hide: 800
  						},
  		  			animation:false,
					viewport: {selector: "body", padding: 0},
  					placement: function() {

						var placement ='auto';

							jQuery( ".popover").addClass( "zubehoer-popover-box" );
							return placement;
						},
  						title: function() {
  							return $('.' + name + '-' + $(this).data('artikel') + " .css-popover-title").html();
  						},
  						content: function() {
  							return $('.' + name + '-' + $(this).data('artikel') + " .css-popover-content").clone();
  						}
  		  		})
  		  		.on("mouseenter", function () {
  		  		    var _this = this;
  		  		    // $(".popover").popover('hide');
  		  		    $(this).popover("show");
  		  		    $(".popover").on("mouseleave", function () {
  		  		        $(_this).popover('hide');
  		  		    });
  		  		}).on("mouseleave", function () {
  		  		    var _this = this;
  		  		    setTimeout(function () {
  		  		        if (!$(".popover:hover").length) {
  		  		            $(_this).popover("hide");
  		  		        }
  		  		    }, 300);
  		  		});		  		
  		  	},300);				
  		  },
        
        post_data: function (url, data) {
        	var that=this;
	      	jQuery.ajax({
					type: 'POST',
					url: that.options.ioPath + url,
					data: data,
					showNoSuggestionNotice: true,
					dataType: 'json',
			    beforeSend: function(jqXHR) {
		        jqXHR.overrideMimeType('text/json;charset=iso-8859-1');
			    },
					success: function(data,responseText,jqXHR) {
						if( jqXHR.status == 204 ) {
							that.debug('sorry, here is nothing to do for me. (Token problem?)')
							return false;
						}
						if( jqXHR.status == 404 ) {
							that.debug('sorry, here is nothing to show you.')
							return false;
						}
						if( jqXHR.status == 403 ) {
							that.debug('sorry, this is no place for you.')
							return false;
						}
						//debug(data);
						if( data.script )	{
							eval(data.script);
						}
            $("body").trigger('contentChanged');
					},
					error: function() {
						that.debug('something is wrong....anything buggy?');
					},
					complete: function() {
							
					}
			});
		},
   };

    $.cssZubehoer = function(options) {
    	$.cssZb = new cssZubehoerClass(options);
    	$.cssZb.register();
    	$.cssZb.calcBundle();
  		$("body").on('shown.bs.modal', '#modal-article-dialog', function () {
	  	    setTimeout(function() { $.cssZb.initZubehoerPopOver('bundle');  $.cssZb.calcBundle(); $.cssZb.initZubehoerPopOver('zubehoer'); },300);
  		});
    	$(document).on('evo:contentLoaded', function() {
		    setTimeout(function() { $.cssZb.initZubehoerPopOver('bundle');  $.cssZb.calcBundle(); $.cssZb.initZubehoerPopOver('zubehoer'); },300);
	    });
    	return $.cssZb;
    };
})(jQuery);


